#! /usr/bin/env python
#-*- coding: utf-8 -*-

import wx
import random, cStringIO, os, sys
import Image
from reportlab.pdfgen import canvas
from reportlab.lib.pagesizes import A4
from reportlab.lib.units import cm

path = os.path.abspath(sys.argv[0])
chemin_images = os.path.join(os.path.split(path)[0],'images')
chemin_modeles = os.path.join(os.path.split(path)[0],'modeles')
chemin_licence = os.path.join(os.path.split(path)[0],'licence')
chemin_tmp = os.path.join(os.path.split(path)[0],'tmp')
fic_tmp = os.path.join(chemin_tmp, "tmp.png")

class MonAffichTexte(wx.ScrolledWindow):
    def __init__(self, parent, fichier):
        wx.ScrolledWindow.__init__(self, parent=parent, id=-1)
        sizer = wx.BoxSizer(wx.VERTICAL)
        fic = open(fichier, "r")
        contenu = fic.read()
        fic.close()
        self.visuTexte = wx.TextCtrl(self,
                                     id=-1,
                                     value=contenu,
                                     style=wx.TE_MULTILINE|wx.TE_READONLY|wx.TE_LEFT|wx.TE_DONTWRAP)
        sizer.Add(self.visuTexte, 1, wx.EXPAND)
        self.SetSizer(sizer)
        sizer.Fit(self)
        self.SetScrollRate(20, 20)

class APropos(wx.Dialog):
    def __init__(self, parent):
        wx.Dialog.__init__(self, parent=parent, title=u"A propos de LotoEduc", size=(500, 500))
        image = wx.StaticBitmap(self, -1,
                                wx.Bitmap(os.path.join(chemin_images, "a_propos_bipede.png"),
                                wx.BITMAP_TYPE_PNG))
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(image, 0, flag=wx.EXPAND|wx.TOP|wx.BOTTOM, border=10)
        ntbook = wx.Notebook(self, -1)
        copyright = wx.Panel(ntbook, -1)
        copSizer1= wx.BoxSizer(wx.VERTICAL)
        copSizer2= wx.BoxSizer(wx.HORIZONTAL)
        mess = u"LotoEduc 2.02\n"
        mess = mess + u"réalisé en wxPython\n\n"
        mess = mess + u"copyright (C) 2008 Alain DELGRANGE aka bipede\n"
        mess = mess + u"Licence GNU-GPL version 2\n\n"
        label = wx.StaticText(copyright, -1, label=mess, style=wx.ALIGN_CENTRE)
        copSizer2.AddStretchSpacer()
        copSizer2.Add(label, 5, wx.EXPAND)
        copSizer2.AddStretchSpacer()
        copSizer1.AddStretchSpacer()
        copSizer1.Add(copSizer2, 2, wx.EXPAND)
        copSizer1.AddStretchSpacer()
        copyright.SetSizer(copSizer1)
        copSizer1.Fit(copyright)
        copyright.SetAutoLayout(True)
        ntbook.AddPage(copyright, u"Copyright")
        licence = MonAffichTexte(ntbook, os.path.join(chemin_licence, "GNU_GENERAL_LICENCE.txt"))
        ntbook.AddPage(licence, u"licence")
        sizer.Add(ntbook, 1, flag=wx.EXPAND)
        sizerbouton = self.CreateButtonSizer(wx.OK)
        sizer.Add(sizerbouton, flag=wx.ALIGN_RIGHT|wx.ALL, border=10)
        self.SetSizer(sizer)
        self.SetAutoLayout(True)
                                                                                                                                                               
class MyFileDropTarget(wx.FileDropTarget):
    def __init__(self, window):
        wx.FileDropTarget.__init__(self)
        self.window = window

    def OnDropFiles(self, x, y, filenames):
        if len(filenames) > 1:
            dlg = wx.MessageDialog(None,
                                   u"Vous ne pouvez faire glisser qu'une image à la fois !",
                                   u"Opération interdite",
                                   style=wx.OK|wx.ICON_ERROR)
            rep = dlg.ShowModal()
            dlg.Destroy()
            return
        file = filenames[0]
        try:
            imgfic = Image.open(file)
        except:
            dlg = wx.MessageDialog(None,
                                   u"Le format du fichier n'est pas correct !",
                                   u"Opération impossible",
                                   style=wx.OK|wx.ICON_ERROR)
            rep = dlg.ShowModal()
            dlg.Destroy()
            return
        width, height = imgfic.size
        if width > height:
            if width > 72:
                facteur = 1 - ((float(width) - 72)/float(width))
                newWidth = 72
                newHeight = int(height * facteur)
                posX = 0
                posY = (72 - newHeight)/2
                imgfic = imgfic.resize((newWidth, newHeight), Image.ANTIALIAS)
            elif width < 72:
                facteur = 1 + ((72 - float(width))/float(width))
                newWidth = 72
                newHeight = int(height * facteur)
                posX = 0
                posY = (72 - newHeight)/2
                imgfic = imgfic.resize((newWidth, newHeight), Image.ANTIALIAS)
            else:
                posX = 0
                posY = (72 - height)/2
        elif height > width:
            if height > 72:
                facteur = 1 - ((float(height) - 72)/float(height))
                newWidth = int(width * facteur)
                newHeight = 72
                posY = 0
                posX = (72 - newWidth)/2
                imgfic = imgfic.resize((newWidth, newHeight), Image.ANTIALIAS)
            elif height < 72:
                facteur = 1 + ((72 - float(height))/float(height))
                newHeight = 72
                newWidth = int(width * facteur)
                posY = 0
                posX = (72 - newWidth)/2
                imgfic = imgfic.resize((newWidth, newHeight), Image.ANTIALIAS)
            else:
                posY = 0
                posX = (72 - width)/2
        else:
            if height == 72:
                posY = 0
                posX = 0
            else:
                posY = 0
                posX = 0
                imgfic = imgfic.resize((72, 72), Image.ANTIALIAS)
        imgfic.save(fic_tmp)
        bmp = wx.Bitmap(fic_tmp, wx.BITMAP_TYPE_PNG)
        bmpCtrl = wx.EmptyBitmap(72, 72)
        dc = wx.MemoryDC(bmpCtrl)
        noBrush = wx.Brush(wx.WHITE, wx.TRANSPARENT)
        dc.Clear()
        dc.SetPen(wx.LIGHT_GREY_PEN)
        dc.SetBrush(wx.WHITE_BRUSH)
        dc.DrawRectangle(0, 0, 72, 72)
        dc.DrawBitmap(bmp, posX, posY)
        dc.SetBrush(noBrush)
        dc.DrawRectangle(0, 0, 72, 72)
        self.window.SetBitmap(bmpCtrl)

class Emplacement(wx.Window):
    def __init__(self, parent):
        wx.Window.__init__(self, parent, -1, size=(72, 72))
        self.grille = parent
        self.imgFond = getbipedeBitmap()
        self.bmp = self.imgFond
        self.alim = False

        dt = MyFileDropTarget(self)
        self.SetDropTarget(dt)
        
        self.Bind(wx.EVT_PAINT, self.OnPaint)
        
    def OnDrop(self, event):
        print event.GetFiles()
        
    def OnPaint(self, event):
        dc = wx.PaintDC(self)
        dc.Clear()
        dc.DrawBitmap(self.bmp, 0, 0)
        
    def SetBitmap(self, bmp):
        self.bmp = bmp
        if self.alim == False:
            self.alim = True
            self.grille.nbImg += 1
        self.grille.pictures[self.grille.images[self]] = bmp
        self.Refresh()
        self.grille.frame.SetNumber()
        
    def Init(self):
        self.bmp = self.imgFond
        self.alim = False
        self.Refresh()
        
class GrilleImages(wx.Panel):
    def __init__(self, parent, frame, nbre):
        wx.Panel.__init__(self, parent, -1)
        self.frame = frame
        self.nbre = nbre
        if nbre == 6:
            lignes = 2
            colonnes = 3
            ecart = 30
        elif nbre == 8:
            lignes = 2
            colonnes = 4
            ecart = 20
        elif nbre == 12:
            lignes = 3
            colonnes = 4
            ecart = 15
        else:
            lignes = 3
            colonnes = 5
            ecart = 10
        self.images = {}
        self.pictures = []
        self.nbImg = 0
        sizer = wx.GridSizer(lignes, colonnes, 0, 0)
        for x in range(nbre):
            img = Emplacement(self)
            sizer.Add(img, 0, wx.ALL, ecart)
            self.images[img] = x
            self.pictures.append(None)
        self.SetSizer(sizer)
        self.Fit()
                   
    def GetImages(self):
        return self.pictures
        
    def GetNumber(self):
        return self.nbImg
        
    def Reinit(self):
        for ctrl in self.images:
            if self.pictures[self.images[ctrl]]:
                ctrl.Init()
                self.pictures[self.images[ctrl]] = None
        self.nbImg = 0

class ParamDialog(wx.Dialog):
    def __init__(self, parent):
        wx.Dialog.__init__(self, parent=parent, title=u"Saisie des paramètres")
        sizer = wx.BoxSizer(wx.VERTICAL)
        label = wx.StaticText(self, -1, u"Saisir le nom de la nouvelle grille LotoEduc", style = wx.ALIGN_CENTRE)
        self.titre = wx.TextCtrl(self, -1, "")
        label2 = wx.StaticText(self, -1, u"Nbre de cases\npour la grille :")
        self.choix = wx.Choice(self, -1, choices = ["6", "8", "12", "15"])
        sizer0 = wx.BoxSizer(wx.HORIZONTAL)
        sizer0.AddStretchSpacer()
        sizer0.Add(label, 0)
        sizer0.AddStretchSpacer()
        sizer.Add(sizer0, 0, wx.ALL|wx.EXPAND, 10)
        sizer.Add(self.titre, 0, wx.ALL|wx.EXPAND, 10)
        sizer1 = wx.BoxSizer(wx.HORIZONTAL)
        sizer1.Add(label2, 1, wx.ALL, 4)
        sizer1.Add(self.choix, 1, wx.ALL, 4)
        sizer.Add(sizer1, 0, wx.ALL|wx.EXPAND, 10)
        sizerbouton = self.CreateButtonSizer(wx.OK|wx.CANCEL)
        sizer.Add(sizerbouton, flag=wx.ALIGN_CENTRE|wx.ALL, border=10)
        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        self.Fit()
        self.titre.SetFocus()
        
    def GetTitre(self):
        return self.titre.GetValue()
        
    def GetNbreCases(self):
        return self.choix.GetStringSelection()
        
class MyFrame(wx.Frame):
    def __init__(self):
        wx.Frame.__init__(self, None, -1, style=wx.CAPTION)
        self.SetIcon(wx.Icon(os.path.join(chemin_images, "bipede.png"), wx.BITMAP_TYPE_PNG))
        boucle = True
        while boucle:
            dlg = ParamDialog(None)
            rep = dlg.ShowModal()
            titre = dlg.GetTitre()
            nbre = dlg.GetNbreCases()
            dlg.Destroy()
            if (nbre != "" and titre != "") or rep != wx.ID_OK:
                boucle = False
        if rep == wx.ID_CANCEL:
            self.Destroy()
        self.SetTitle("LotoEduc - %s (%s cases)"%(titre, nbre))
        self.titre = titre
        self.cases = int(nbre)
        panel = wx.Panel(self, -1)
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizerLb = wx.BoxSizer(wx.HORIZONTAL)
        sizerGr = wx.BoxSizer(wx.HORIZONTAL)
        sizerBt = wx.BoxSizer(wx.HORIZONTAL)
        label = wx.StaticText(panel, -1,
                              u"Pour constituer une grille, glisser-déposez les images désirées\nsur les emplacements appropriés",
                              style = wx.ALIGN_CENTER)
        sizerLb.AddStretchSpacer()
        sizerLb.Add(label, 0)
        sizerLb.AddStretchSpacer()
        self.grille = GrilleImages(panel, self, self.cases)
        sizerGr.AddStretchSpacer()
        sizerGr.Add(self.grille, 0)
        sizerGr.AddStretchSpacer()
        self.gauge = wx.Gauge(panel, -1, 0)
        self.btConst = wx.Button(panel, -1, u"Fabriquer le PDF")
        self.btReinit = wx.Button(panel, -1, u"Réinitialiser la grille")
        self.btQuit = wx.Button(panel, -1, u"Quitter l'application")
        self.btWhat = wx.Button(panel, -1, u"A propos de...")
        sizerBt.Add(self.btConst, 1, wx.ALL, 3)
        sizerBt.Add(self.btReinit, 1, wx.ALL, 3)
        sizerBt.Add(self.btQuit, 1, wx.ALL, 3)
        sizerBt.Add(self.btWhat, 1, wx.ALL, 3)
        sizer.Add(sizerLb, 0, wx.LEFT|wx.TOP|wx.RIGHT|wx.EXPAND, 10)
        sizer.Add(sizerGr, 0, wx.ALL|wx.EXPAND, 20)
        sizer.Add(self.gauge, 1, wx.LEFT|wx.BOTTOM|wx.RIGHT|wx.EXPAND, 10)
        sizer.Add(sizerBt, 0, wx.LEFT|wx.BOTTOM|wx.RIGHT|wx.EXPAND, 10)
        panel.SetSizer(sizer)
        self.btConst.Enable(False)
        self.btReinit.Enable(False)
        panel.Fit()
        self.Fit()
        self.Centre()
        
        self.Bind(wx.EVT_BUTTON, self.Realiser, self.btConst)
        self.Bind(wx.EVT_BUTTON, self.Initialiser, self.btReinit)
        self.Bind(wx.EVT_BUTTON, self.Quitter, self.btQuit)
        self.Bind(wx.EVT_BUTTON, self.A_propos, self.btWhat)
        
    def Realiser(self, event):
        fic_sortie = os.path.join(chemin_modeles, "%s.pdf"%(self.titre))
        if wx.Platform == "__WXMSW__":
            fic_sortie = fic_sortie.encode("iso-8859-15")
        else:
            fic_sortie = fic_sortie.encode("utf-8")
        self.btConst.Enable(False)
        self.btReinit.Enable(False)
        self.btQuit.Enable(False)
        if self.cases == 6:
            coordonnees = [(41, 65), (167, 65), (292, 65), (41, 201), (167, 201), (292, 201)]
            liste = [[-1, -1, -1]]
            nbTirages = 15
        elif self.cases == 8:
            coordonnees = [(41, 65), (133, 65), (225, 65), (317, 65), (41, 201), (133, 201),
                           (225, 201), (317, 201)]
            liste = [[-1, -1, -1, -1]]
            nbTirages = 25
        elif self.cases == 12:
            coordonnees = [(41, 41), (133, 41), (225, 41), (317, 41), (41, 133), (133, 133),
                           (225, 133), (317, 133), (41, 225), (133, 225), (225, 225), (317, 225)]
            liste = [[-1, -1, -1, -1, -1, -1]]
            nbTirages = 25
        else:
            coordonnees = [(21, 41), (100, 41), (179, 41), (258, 41), (337, 41), (21, 133), (100, 133),
                           (179, 133), (258, 133), (337, 133), (21, 225), (100, 225), (179, 225),
                           (258, 225), (337, 225)]
            liste = [[-1, -1, -1, -1, -1, -1, -1]]
            nbTirages = 25
        nbre = 0
        self.gauge.SetRange(nbTirages + 1)
        self.gauge.SetValue(0)
        while nbre < nbTirages:
            tirage = random.sample(range(self.cases), self.cases/2)
            tirage.sort()
            if tirage not in liste:
                nbre += 1
                liste.append(tirage)
        c = canvas.Canvas(fic_sortie)
        c.setPageSize(A4)
        largFeuille, hautFeuille = A4
        place = 0
        valgauge = 0
        for x in range(len(liste)):
            valgauge += 1
            bmp = wx.EmptyBitmap(428, 336)
            dc = wx.MemoryDC(bmp)
            dc.SetPen(wx.BLACK_PEN)
            dc.SetBrush(wx.WHITE_BRUSH)
            dc.DrawRectangle(0, 0, 428, 336)
            boucle = -1
            listimg = self.grille.GetImages()
            for y in range(self.cases):
                boucle += 1
                posX, posY = coordonnees[boucle]
                if y in liste[x]:
                    dc.DrawBitmap(getbipedeBitmap(), posX, posY)
                else:   
                    dc.DrawBitmap(listimg[y], posX, posY)
            bmp.SaveFile(fic_tmp, wx.BITMAP_TYPE_PNG)
            im = Image.open(fic_tmp)
            if valgauge > 1:
                im = im.rotate(90)
                largIm, hautIm = im.size
                newlarg = int((largFeuille - 60)/2)
                ratio = 1-((largIm - newlarg)/float(largIm))
                newhaut = int(hautIm * ratio)
                im = im.resize((newlarg, newhaut), Image.ANTIALIAS)
                posX1 = 20
                posX2 = 40 + newlarg
                posY1 = (hautFeuille - 40) - newhaut
                posY2 = (hautFeuille - 80) - (2*newhaut)
            else:
                largIm, hautIm = im.size
                posX2 = int((largFeuille - largIm)/2)
                posY1 = (hautFeuille - 40) - hautIm
                place = 1
            if place == 0:
                c.drawInlineImage(im, posX1, posY1)
                place = 1
                if x == nbTirages:
                    c.showPage()
            elif place == 1:
                c.drawInlineImage(im, posX2, posY1)
                place = 2
                if x == nbTirages:
                    c.showPage()
            elif place == 2:
                c.drawInlineImage(im, posX1, posY2)
                place = 3
                if x == nbTirages:
                    c.showPage()
            else:
                c.drawInlineImage(im, posX2, posY2)
                place = 0
                c.showPage()
            self.gauge.SetValue(valgauge)
            app.Yield()
        c.save()
        if wx.Platform == "__WXMSW__":
            mess = u"Le fichier\n\n%s\n\na été constitué.\n\nVoulez-vous le visualiser ?"%(fic_sortie.decode("iso-8859-15"))
        else:
            mess = u"Le fichier\n\n%s\n\na été constitué.\n\nVoulez-vous le visualiser ?"%(fic_sortie.decode("utf-8"))
        dlg = wx.MessageDialog(None,
                               mess,
                               u"Traitement terminé",
                               style = wx.YES_NO|wx.ICON_QUESTION)
        rep = dlg.ShowModal()
        dlg.Destroy()
        self.gauge.SetValue(0)
        self.btReinit.Enable(True)
        self.btQuit.Enable(True)
        if rep == wx.ID_YES:
            if wx.Platform != "__WXMSW__":
                fic_sortie = '"%s"'%fic_sortie
            ft = wx.TheMimeTypesManager.GetFileTypeFromExtension("pdf")
            if ft:
                cmd = ft.GetOpenCommand(fic_sortie)
                print cmd
                resu = wx.Execute(cmd)
            else:
                dlg = wx.MessageDialog(None,
                                       u"Aucune application n'est liée aux fichiers PDF sur votre système",
                                       u"Visualisation impossible",
                                       style = wx.CANCEL|wx.ICON_ERROR)
                res = dlg.ShowModal()
                dlg.Destroy()
        
    def A_propos(self, event):
        dlg = APropos(self)
        res = dlg.ShowModal()
        dlg.Destroy()
        
    def Initialiser(self, event):
        self.btReinit.Enable(False)
        self.btConst.Enable(False)
        self.grille.Reinit()
        
    def Quitter(self, event):
        self.Destroy()
        
    def SetNumber(self):
        if self.grille.GetNumber() == self.cases:
            self.btConst.Enable(True)
        self.btReinit.Enable(True)
        
class MyApp(wx.App):
    def OnInit(self):
        f = MyFrame()
        f.Show(True)
        self.SetTopWindow(f)
        return True

def getbipedeData():
    return \
'\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00H\x00\x00\x00H\x08\x02\x00\
\x00\x00\xda\x8f$\x10\x00\x00\x00\x01sRGB\x00\xae\xce\x1c\xe9\x00\x00\x00\tp\
HYs\x00\x00\x0b\x13\x00\x00\x0b\x13\x01\x00\x9a\x9c\x18\x00\x00\x00\x07tIME\
\x07\xd8\x0c\x02\x11/0ta\xd0\xee\x00\x00\x00\x1dtEXtComment\x00Created with \
The GIMP\xefd%n\x00\x00\x04~IDATh\xde\xedZ\xdbr\xa2Z\x10\xed\r\xa8\x80\x8a\\\
\x8ch$\x91\xb2j\xaa\xa6\xe6\xff\x7f%/V\x9d\x1a\xccAg\x14o\xf1\x12\x95\x88\
\x9c\x07"\xa5Bp\x83\x18\xd1C?\x05jKXt\xf7\xea\xd5\xbd7\xfa\xf7\xf7o\xb8G\xa3\
\x00@Q\xd5;C\xa5k\x1a\x01wj)\xb0\x14X\n,\x05\x96\x02\xfb_\x00\xa3.\xf1\xd0~\
\xdf0\xdf\x17b\xa5\xc2\xb2\xec\x9d\x00\xd35\xcd\xfd{\xd4\xef/\x8bEI\x92n>\
\x14\xf7Q9\xb6\x9c\xcdn>\xc7\xf4\xd7\xd7;%\x8f\xed\xf6\x1e\x80\xcd\xe7\xf3n\
\xb7k\xdb\xb6siY\xd6=\xd0\xbd\xaei\x93\xc1`k\x9a\x9dv\xdb\xb9\xb3X\xbc\xfb\
\xae\x94\xe4\xea\xcd\x00\xdbl6\xfb\x97\x86a\x00\x00\x80\xed\xbb\x98a\xe8\x9b\
\x01\xb6X,\xf6/\xd7\x8b\x05\x000\x0cs\xf3\xa1\x98\xcf\xe7\xbd73\x99\x8c\xf7\
\xe6u\x1bs\xac\x02m\xdb\xb6\x93N\x8a\xaaR\x14\xd6O\xc4J\xe5\x06<\xe6\x92\x84\
S\x82\xf3%>\xd8?\xc2\xc3\xc3\x15\xc5TDI5\x1e\x8f\x05A\x18\x8fGY\x82\x00\x00\
\x8a\xce%$\xf6\xce\x05\xb6x{\x13\x04\xa1\xd9lZ\x96eYV6\x9b\xdd\xd5\xe7m\xf7P\
|\xf0\xe5r\xa1P\xb8=\x11L\x92$I\x92\x000\x9b\xcd\xde\x86C\xef\x82\xc9`\xb0\
\xd9lx\x9eOn\x8e}\x15c\x96e\xe9\x9a\xe6\x8b\xeaS\xa0L&I\xf4\xd8`0X\xcd\xe7\
\x00 VdEU\x8f\xc4\xbba\x18\xeb\xc3\x9a\x16\xd6\\\xb2\xbdD~\x06\x01sP\x01\xc0\
\xa8\xdf\xcb*\xca\xfe\xffn\xb5Z\xec.\xbb"\x9b\x8b\xca\xe5\xdb\x18\xe1\xe1\
\x16\xe8\xbf\xba\x1e/*_{yy\xf9\x0e`\x14M\x1fE\x0e\x00\x0c\x87C|T\xa5\x90\xed\
s)\x9f_\xafW\x17\x07V\xadV-\x84\x8e\xb0\x85j\x8a\x8b\xc5b\xd8\x172\xfe\xfc\
\xfd\x0e\xbao4\x1a\xb6mO\xa7S\x8a\xca \x84\xbc\xcd\x7f\x80\xc9\xf5z\\\xb3\
\x86\x08\xb9w:\xc7\x10B\xa5R)\x9f\x0f-\x91|\x95q\xb4\tJ\xa8\x0f\x1aZ\xdd\x87\
\x8a~\x9co\xfc\xf8\xfc\x9c\x08\xe51\xe8\x1b\x98+\xeb\x8d\x86\xb7Ry\xd1\x12\
\xc4\x05\xc7\xb5!\x1em\xe3\r6\xcaU\x19!\x04\x00\xe6\xde\xec\xc0\xb1\xe5r\xf9\
mN\x0b\x01\x0c\x93\xbbi\xfa\xb3\x9b\xeew\xbb\xc1\xdd\xb7\xe34N\x141)\xa7\xdd\
n\xeb\x9a\xa6k\xda\x02C\xf1\x84\x00\x86\xc3\xddn\xb0\xb9\x03\xacC:\xf1)\x80\
\x1c\xc7\x95\xab\xd5\xdd\xf0G\xfe\xaa\x197M\x93\xdc=sl\x18q\xe6\x18\x00L\xe7\
s\x0e\xaf\x13A\x87\x05p\xf7i\n_8\x99\xf6\x92\r\xcbq\xef\xd3\xa9\x1b\xae^\xff\
\xc7\t\xec\xe7\xaf_\xdd3&\xbe^\xb6\xf0\xf2x&\x97\x93k5\x00\x10EQ<\x8c\xd2\
\x0b\x02#\x08\xa2\xc0\xf3\x01\xcd\x88\xf3\xa2\x9c(NG\xa3P\x95\xca\xb5\x8f\
\xf5\xda\xb9_o4|\xdd\x0e\x00\xb5\xa7\xa7\xf8\xa7T<\xcf\xd3\x85\x13\xc9\xe6\
\x8b*\xacz\xe8\xb4\xdb\x1d\xbf\xe8\x10+2I\x92\xaf\x9a\xa6k\x9ao&G\x04\x06\
\x00\xe5\xb2$\xc9r\xa8\x9f\x84]\xff\xc9@\xdb\xad\xaei\xce\xcbW\x15\xa5$I\x8a\
\xaa\xb2,\xe3\x9eO9*\'\xe7\x02\x03\x00\x86a\xf0=\xc0\x89\xe29\x13\xd5N[\xb3m\
\x9b\xa2(\x87\x961\xe5\xd5Y\xb5_QUWd\x04Ha\x8e\xe3\xceoI\x03\xa2.\xe6a\x8eK\
\xeb\x8e\xebl\xdb^.\x97\xe3\xe1\xd0\xb6,"\x93aXV\x10\x84\x93\xf19\xec\xf5\
\xf0\xb1)\xaa\xba=\xdc\xac\n\x10.\xb1m\xd5"\x84X\x96\r5\'\r\x1b\x9f\x93\xc9d\
\x7f\xe6\x15\x9c\x0b\x17\xd9\\\xc7\xb7z\xa3\x11@\x00\xde\x99\x17\xcf\xf3\x98\
\xb9}\xe5\xe3\x10\x08!\xbe\\\xc6_\xff\xf1\xf1\x11\xbf\x08\x8e\xcb\x8eh\xa0P(\
\x98\xd8\xdb\xbc\xbdN\xe7\x9b\xc8\xe3\x9c\xbeX\xae\xd7\x1d\xc9\xdbl6\xffi\
\xb5r\xb1N\xbe\x88+\xfa\xaa\xd7\xe9\xfc\xd9\x8dn\x9a?~\\\xad\x1f;\xdf\xb6\
\x9e\x90\xb3\xd6+g\xef\x17!\x84\xb3\xa5\x96e\xd8$\x02\xf3\x15\xb5\xa6i~\xf6)\
\x18\xa5\xa2"W\x92\x08\xccw\xc8q\xa1-\xc2\xeb\x9f~s\x13\xef\xa4h:)\xdf\xae\
\xc9\x8a\x95\xc7\xc7\xa3^\x18\xb3@?\xd4j_\xb5g\x89\xf0X6\x12\xa7Kr5\x97\xcb%\
=\x14CE\x14\x00\xd4\x9e\x9e#\x1c\x84\xb9\x020\x84\x10&\xb6\\>\xaf\xa8*IFy\
\xc9\xeb\x88`\xa7\xd9\th\x19K\x92\x14a\xa7&)\xea\xde\xd5\xe9\xab\xd5\x8a \
\x08\x82 H\x92\x0c\xc5\x10\xc9m[\x1c\xa3\xe9\xf8\xcf\x92\xa5\xc7\xd3S`)\xb0\
\x14X\n,\x05v\xcbFA\xa4\xc3\x06\xc9\xb7\xff\x00\x00~\xb4\xb1~K\x84G\x00\x00\
\x00\x00IEND\xaeB`\x82' 

def getbipedeBitmap():
    return wx.BitmapFromImage(getbipedeImage())

def getbipedeImage():
    stream = cStringIO.StringIO(getbipedeData())
    return wx.ImageFromStream(stream)
        
if not os.path.isdir(chemin_modeles):
    os.mkdir(chemin_modeles)
    os.mkdir(chemin_tmp)

app = MyApp()
app.MainLoop()
